Commits

Anonymous committed a2f645c

Import from CVS: tag r20-3b24

Comments (0)

Files changed (127)

 							-*- indented-text -*-
+to 20.3 beta24 "Ljubljana"
+-- Interface change:  custom-loads now snarfed separately from autoloads.
+-- custom snarfing code rewritten
+-- iswitchb.el added from Emacs 20.2
+-- NT DOC file fix from David Hobley
+-- jpeg detection corrected
+-- bytecode fix to char-syntax
+-- gnuserv.el reverted to 3.09
+-- Various patches/Emacs 20.1 synchs from Hrvoje Niksic
+-- Miscellaneous bug fixes
+
 to 20.3 beta23 "Sarajevo"
 -- Other new and older Hrvoje Niksic patches
 -- 20.1 synching by Hrvoje Niksic
+1997-09-27  SL Baur  <steve@altair.xemacs.org>
+
+	* XEmacs 20.3-beta24 is released.
+
+1997-09-27  Hrvoje Niksic  <hniksic@srce.hr>
+
+	* Makefile.in (custom-loads): New target.
+
+1997-09-24  SL Baur  <steve@altair.xemacs.org>
+
+	* etc/BETA (XEmacs 20.3 packages): Added explanation of package
+	hierarchy.
+
+1997-09-23  SL Baur  <steve@altair.xemacs.org>
+
+	* lwlib/xlwmenu.c: Fix compilation problem with USE_XFONTSET.
+	From Kazuyuki IENAGA <ienaga@jsys.co.jp>
+
+1997-09-22  SL Baur  <steve@altair.xemacs.org>
+
+	* XEmacs 19.16-pre4 is released.
+
 1997-09-20  SL Baur  <steve@altair.xemacs.org>
 
 	* XEmacs 20.3-beta23 is released.
 autoloads: src
 	MAKE='$(MAKE)' sh ${srcdir}/lib-src/update-autoloads.sh
 
+custom-loads:
+	MAKE='$(MAKE)' sh ${srcdir}/lib-src/update-custom.sh
+
 finder: src
 	@(cd lisp/utils; \
 		../../src/xemacs -batch -q -no-site-file \
 you will probably lose due to tab expansion.  The best thing to do is to
 M-x cd to the appropriate directory, and issue the command `C-u M-!' from
 within XEmacs.
+
+* XEmacs 20.3 packages
+
+XEmacs 20.3 has added the concept of installable packages searched prior
+to dump time when building.
+
+Packages are searched by default under /usr/local/lib/xemacs/packages/.
+The summary message in configure will tell you where XEmacs is looking 
+for them.  The packages hierarchy differs from site-lisp in that you
+do not have install XEmacs to use it, indeed, the package path is
+searched prior to dump time so that installed packages have the same
+status as lisp distributed in the xemacs base tarball.
+
+The structure of each directory in the package search path should look
+like the base installed directory (ie. have etc/, info/, and lisp/,).
+Lisp is searched recursively.  It and all subdirectories are added to
+the `load-path'.  Each etc directory is added to `data-directory-list',
+and each info directory is added to `Info-default-directory-list'.
+
+A `find . -type d -print' in my top-level package directory reveals:
+./etc
+./etc/auctex
+./etc/auctex/style
+./etc/gnus
+./etc/skk
+./etc/gnusrefcard
+./etc/smilies
+./etc/message
+./info
+./lisp
+./lisp/gnus
+./lisp/auctex
+./lisp/auctex/man
+./lisp/footnote
+./lisp/skk
+
+
+AUCTeX and Gnus have package tarballs in
+	ftp://ftp.xemacs.org/pub/beta/packages-20.3/
+that you can simply untar in a package directory to install.
+
+Karl Hegbloom has a set of packages in
+	[I lost the reference]
+that work the same way.
+
+This is not how package installation will work in released 20.3.
 `save-current-buffer' in Lisp mode, `call/cc' to
 `call-with-current-continuation' in Scheme mode, etc.
 
-** Customize now has a new `browser' mode of traversing
-customizations, which is in many ways easier to follow than the
-standard one.  Try it with `M-x customize-browse'.
-
 ** `C-x n d' now runs the new command `narrow-to-defun',
 which narrows the accessible parts of the buffer to just
 the current defun.
 previous echo area contents are restored (in case the command prints
 something useful).
 
+** If you set scroll-conservatively to a small number, then when you
+move point a short distance off the screen, XEmacs will scroll the
+screen just far enough to bring point back on screen, provided that
+does not exceed `scroll-conservatively' lines.
+
+** Customize changes.
+
+*** Customize has undergone a massive speedup, and should now operate
+acceptably fast.  Slowness of the interface used to be the biggest
+gripe.
+
+*** Many more packages have been modified to use the facility, so
+almost all of XEmacs options can be examined through the Customize
+groups.
+
+*** There is a new `browser' mode of traversing customizations, in
+many ways easier to follow than the standard one.  Try it out with
+`M-x customize-browse'.
+
 ** Pending-delete changes.
 
 *** Pending-delete is now a minor mode, with the normal minor-mode
 
 ** Package starting changes.
 
-*** Loading `paren.el' is no longer sufficient to enable
-paren-blinking.  Use `paren-set-mode' explicitly, or customize
-`paren-mode'.
-
-*** Loading `uniquify.el' is no longer sufficient to enable uniquify;
-you have to set `uniquify-buffer-name-style' to a legal value.
-
-*** Loading `time.el' is no longer sufficient to enable display time;
-you have to invoke `display-time' explicitly.
-
-*** Loading `jka-compr.el' is no longer sufficient to enable
-on-the-fly compression; you have to use `toggle-auto-compression'.
+*** Loading `paren' no longer enables paren-blinking.  Use
+`paren-set-mode' explicitly, or customize `paren-mode'.
+
+*** Loading `uniquify' no longer enables uniquify.  Set
+`uniquify-buffer-name-style' to a legal value.
+
+*** Loading `time' no longer enables display time.  Invoke
+`display-time' explicitly.
+
+*** Loading `jka-compr' no longer enables on-the-fly compression.  Use
+`toggle-auto-compression' instead.
+
+*** Loading `id-select' no longer enables its behaviour.  Use
+`id-select-install' instead.
 
 ** XEmacs can now save the minibuffer histories from various
 minibuffers.  To use this feature, add the line:
 
 Or `M-x customize-group RET add-log RET'.
 
-** The `M-x customize' command now automatically customizes `Emacs'
-group (top of the customize tree).  Use `M-x customize-group' to
-customize settings of a specific group.
+** The key C-x m no longer runs the `mail' command directly.
+Instead, it runs the command `compose-mail', which invokes the mail
+composition mechanism you have selected with the variable
+`mail-user-agent'.  The default choice of user agent is
+`sendmail-user-agent', which gives behavior compatible with the old
+behavior.
+
+C-x 4 m now runs compose-mail-other-window, and C-x 5 m runs
+compose-mail-other-frame.
+
+** When you kill a buffer that visits a file, if there are any
+registers that save positions in the file, these register values no
+longer become completely useless.  If you try to go to such a register
+with `C-x j', then you are asked whether to visit the file again.  If
+you say yes, it visits the file and then goes to the same position.
+
+** When you visit a file that changes frequently outside Emacs--for
+example, a log of output from a process that continues to run--it may
+be useful for Emacs to revert the file without querying you whenever
+you visit the file afresh with `C-x C-f'.
+
+You can request this behavior for certain files by setting the
+variable revert-without-query to a list of regular expressions.  If a
+file's name matches any of these regular expressions, find-file and
+revert-buffer revert the buffer without asking for permission--but
+only if you have not edited the buffer text yourself.
 
 ** Gnuserv changes
 
 ** The PATTERN argument to `split-string' is now optional and defaults
 to whitespace ("[ \f\t\n\r\v]+").
 
+** `set-extent-properties' is a new function that can be used to
+change properties of an extent at once, and is analogous to
+`set-frame-properties'.
+
 ** The new macro `with-current-buffer' lets you evaluate an expression
 conveniently with a different current buffer.  It looks like this:
 

lib-src/ChangeLog

+1997-09-27  Hrvoje Niksic  <hniksic@srce.hr>
+
+	* update-custom.sh: New file.
+
+	* update-autoloads.sh: Minor fixes.
+
 1997-08-11  Jeff Miller <jmiller@smart.net>
 	* Makefile.in.in:  Added a test for system-type equal to linux to
 	lisp/paths.el.  Mail spool dir should be /var/spool/mail.

lib-src/update-autoloads.sh

 
 REAL=`cd \`dirname $EMACS\` ; pwd | sed 's|^/tmp_mnt||'`/`basename $EMACS`
 
-echo "Rebuilding autoloads/custom-loads in `pwd|sed 's|^/tmp_mnt||'`"
+echo "Rebuilding autoloads in `pwd|sed 's|^/tmp_mnt||'`"
 echo "          with $REAL..."
 
 if [ "`uname -r | sed 's/\(.\).*/\1/'`" -gt 4 ]; then
 fi
 
 # Compute patterns to ignore when searching for files
-# These directories don't have autoloads and customizations, or are partially
-#  broken.
-ignore_dirs="cl egg eos ilisp its language locale mel mu sunpro term tooltalk"
+# These directories don't have autoloads or are partially broken.
+ignore_dirs="egg eos ilisp its language locale mel mu sunpro term tooltalk"
 
 # Prepare for autoloading directories with directory-specific instructions
 make_special_commands=''

lib-src/update-custom.sh

+#!/bin/sh
+### update-custom.sh --- update Customize group dependencies
+
+# Author: Hrvoje Niksic, based on update-autoloads.el by
+#   Jamie Zawinski, Ben Wing, Martin Buchholz, and Steve Baur
+# Maintainer: Hrvoje Niksic
+# Keywords: internal
+
+# This file is part of XEmacs.
+
+# XEmacs is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+
+# XEmacs is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+# General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with XEmacs; see the file COPYING.  If not, write to
+# the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+# Boston, MA 02111-1307, USA.
+
+### Commentary:
+
+# This is much simpler than update-autoloads.el.  All we need to do is
+# compute a list of directories we want to use, and feed it to
+# Custom-make-dependencies.  End of story.
+
+### Code:
+
+set -eu
+
+# get to the right directory
+test ! -d ./lisp -a -d ../lisp && cd ..
+if test ! -d ./lisp ; then
+	echo $0: neither ./lisp/ nor ../lisp/ exist
+	exit 1
+fi
+
+EMACS="./src/xemacs"
+echo " (using $EMACS)"
+
+export EMACS
+
+REAL=`cd \`dirname $EMACS\` ; pwd | sed 's|^/tmp_mnt||'`/`basename $EMACS`
+
+echo "Rebuilding custom-loads with $REAL..."
+
+if [ "`uname -r | sed 's/\(.\).*/\1/'`" -gt 4 ]; then
+  echon()
+  {    
+    /bin/echo $* '\c'
+  }
+else
+  echon()
+  {
+    echo -n $*
+  }
+fi
+
+# Compute patterns to ignore when searching for files
+# These directories don't have customizations, or are partially broken.
+# If some of the packages listed here are customized, don't forget to
+#  remove the directory!
+ignore_dirs="cl egg eos ilisp its language locale mel mu sunpro term \
+tooltalk iso mailcrypt oobr tl tm mh-e hyperbole electric apel \
+hm--html-menus gnats pcl-cvs vm"
+
+# Only use Mule XEmacs to build Mule-specific autoloads & custom-loads.
+echon "Checking for Mule support..."
+lisp_prog='(princ (featurep (quote mule)))'
+mule_p="`$EMACS -batch -no-site-file -eval \"$lisp_prog\"`"
+if test "$mule_p" = nil ; then
+	echo No
+	ignore_dirs="$ignore_dirs mule leim"
+else
+	echo Yes
+fi
+
+echon "Checking directories..."
+dirs=
+for dir in lisp/*; do
+	if test -d $dir \
+		-a $dir != lisp/CVS \
+		-a $dir != lisp/SCCS; then
+		for ignore in $ignore_dirs; do
+			if test $dir = lisp/$ignore; then
+				continue 2
+			fi
+		done
+		rm -f "$dir/custom-load.elc"
+		dirs="$dirs $dir"
+	fi
+done
+echo done
+
+$EMACS -batch -q -l cus-dep -f Custom-make-dependencies $dirs
+1997-09-27  Hrvoje Niksic  <hniksic@srce.hr>
+
+	* custom/cus-dep.el (Custom-make-dependencies): Minor fixes.
+
+1997-09-27  SL Baur  <steve@altair.xemacs.org>
+
+	* packages/completion.el: Remove keybinding of M-return for
+	hyperbole.
+	(completion-kill-region): The version of this function in InfoDock
+	4.0pre was very broken for XEmacs due to active region handling
+	and because it didn't set the `this-command' variable properly
+	when doing a kill.
+	From:  Bob Weiner <weiner@altrasoft.com>
+
+1997-09-26  SL Baur  <steve@altair.xemacs.org>
+
+	* utils/autoload.el: Removed code dealing with customization.
+	(update-file-autoloads): Fix typo in DOC string, remove custom code.
+	(update-autoloads-from-directory): Remove custom code.
+	(batch-update-autoloads): Fix DOC string, remove custom code.
+	(batch-update-directory): Fix DOC string, remove custom code.
+
+1997-09-26  Jens-Ulrik Holger Petersen  <petersen@kurims.kyoto-u.ac.jp>
+
+	* prim/help.el (describe-function-at-point): new function.
+	(describe-variable-at-point): ditto.
+	(help-next-symbol): ditto.
+	(help-prev-symbol): ditto.
+	(describe-function): Mention `find-function-function' in
+ 	docstring.  Use `function-history' in completing-read.
+	(describe-function-1): Only print one filename, even if we know
+ 	two!  Use `variable-history' in completing-read.
+	(where-is): Mention `find-function-function' in docstring.
+	(find-function-function): improve docstring.
+	(find-function-noselect): Remove optional arg.  Now finds
+ 	libraries explicitly loaded from outside `load-path' as it should.
+	Search also for cl's defun*.  Return a pair instead of a list.
+	(find-function-read-function): use `function-history'.
+	(find-function-do-it): new function.
+	(find-function): Remove optional arg.  Use `find-function-do-it'.
+	(find-function-other-window): ditto.
+	(find-function-other-frame): ditto.
+	(find-function-at-point): new function.
+
+1997-09-26  Hrvoje Niksic  <hniksic@srce.hr>
+
+	* custom/cus-edit.el: Issue a message about loading customization
+	dependencies.
+
+	* custom/wid-edit.el (widget-map-buttons): Fixed typo.
+
+1997-09-25  SL Baur  <steve@altair.xemacs.org>
+
+	* prim/files.el (after-find-file): Revert synch to Emacs 20 and
+	restore old directory creation behavior.
+
+1997-09-25  Hrvoje Niksic  <hniksic@srce.hr>
+
+	* custom/wid-edit.el (widget-button-or-field-extent): New
+ 	function.
+	(widget-next-button-or-field): Use it.
+	(widget-previous-button-or-field): Ditto.
+	(widget-move): Don't signal an error when there is only one widget
+ 	in the buffer.
+	(widget-push-button-value-create): Cache glyphs themselves,
+ 	instead of instantiators.
+	(widget-documentation-string-value-create): Better help echo
+	(widget-mouse-help): Use `functionp'.
+	(widget-echo-help): Ditto.
+
+1997-09-25  SL Baur  <steve@altair.xemacs.org>
+
+	* prim/glyphs.el (init-glyphs): Fix jpeg signature.
+
+1997-09-24  Jens-Ulrik Holger Petersen  <petersen@kurims.kyoto-u.ac.jp>
+
+	* modes/lazy-shot.el (lazy-shot-shot-function): make the message
+	be displayed as progress.
+
+1997-09-25  Hrvoje Niksic  <hniksic@srce.hr>
+
+	* comint/telnet.el: Minor custom changes.
+
+	* custom/wid-edit.el (widget-field-action): Edit the value in the
+ 	minibuffer.
+
+	* custom/cus-edit.el (custom-group-value-create): Renamed `Go to
+	Group' tag to `Open'.
+
+	* custom/wid-edit.el (widget-shadow-subrs): New variable.
+	(widget-url-link-help-echo): New function.
+	(url-link): Use it.
+	(widget-emacs-library-link-help-echo): New function.
+	(emacs-library-link): Use it.
+
+1997-09-24  Hrvoje Niksic  <hniksic@srce.hr>
+
+	* custom/wid-edit.el (widget-glyph-insert-glyph): Encode the
+	widget information to extent, not to the glyph.
+	(widget-glyph-click): Extract the widget from the extent, not the
+	glyph.
+	(widget-glyph-find): Set up a glyph cache.
+
+	* prim/about.el: Use :button-prefix and :button-suffix instead of
+	the variables.
+
+	* custom/wid-edit.el (widget-field-keymap): Bind Sh-TAB to
+ 	`widget-backward'.
+	(widget-specify-field): Use extents, not overlays.
+	(widget-specify-button): Ditto.
+	(widget-specify-sample): Ditto.
+	(widget-specify-inactive): Ditto.
+	(widget-button-click): Ditto.
+	(widget-field-value-create): Ditto.
+	(widget-field-value-delete): Ditto.
+	(widget-color-notify): Ditto.
+	(widget-setup): Ditto.
+	(widget-map-buttons): Use `map-extents'.
+	(widget-keymap): Made `global-map' its parent.
+	(widget-next-button-or-field): New function.
+	(widget-previous-button-or-field): Ditto.
+	(widget-move): Use them.
+
+	* custom/custom.el (custom-group-hash-table): Use
+	`make-hashtable', with initial size 300.
+	(custom-add-to-group): Update hash-table unconditionally.
+
+1997-09-24  SL Baur  <steve@altair.xemacs.org>
+
+	* prim/packages.el (packages-useful-lisp): Arrange to bytecompile
+	shadow.elc early.
+
+1997-09-22  Karl M. Hegbloom  <karlheg@inetarena.com>
+
+	* x11/x-toolbar.el (Info-frame-plist): Added.
+	(toolbar-info) Use new plist variable to make-frame.
+
+1997-09-24  Hrvoje Niksic  <hniksic@srce.hr>
+
+	* custom/wid-edit.el (widget-button1-click): Would bug out on
+	events with no bindings.
+
+	* custom/cus-edit.el (custom-group-value-create): Update members
+ 	after loading the widget.
+	(custom-group-link-help-echo): New function.
+	(custom-group-link): Use it.
+
+	* prim/cus-load.el (custom-put): Update
+ 	`custom-parent-hash-table'.
+
+	* custom/cus-edit.el (custom-add-parent-links): Use
+	`custom-group-hash-table' to map the groups.
+
+	* custom/custom.el (custom-parent-hash-table): New variable.
+	(custom-add-to-group): Use it.
+
+	* prim/cus-load.el: Don't issue message for every loaded file.
+
+	* custom/cus-edit.el (custom-group-prompt): New function.
+	(customize): Use it.
+	(customize-other-window): Ditto.
+
+	* custom/wid-edit.el (widget-field-keymap): Bind TAB to
+ 	`widget-forward'.
+
+1997-09-23  Hrvoje Niksic  <hniksic@srce.hr>
+
+	* custom/cus-edit.el: Use `display-message' to indicate progress
+	messages.
+	(customize-set-variable): Use the third argument to `get'.
+	(customize-save-variable): Ditto.
+	(custom-variable-value-create): Ditto.
+	(custom-variable-state-set): Ditto.
+	(custom-variable-set): Ditto.
+	(custom-variable-save): Ditto.
+	(custom-variable-reset-saved): Ditto.
+	(custom-variable-reset-standard): Ditto.
+
+	* custom/cus-edit.el: Removed C-coded routines.
+
+	* custom/cus-edit.el (custom-buffer-create-internal): Print a
+	limited number of messages.
+	(custom-group-value-create): Ditto.
+
+	* custom/wid-edit.el (widget-editable-list-value-get): Revert to
+ 	`append'.
+
+1997-09-22  Colin Rafferty  <craffert@ml.com>
+
+	* modes/lazy-shot.el (lazy-shot-shot-function): Made it do its
+		  work in the correct buffer.  Also, changed obsolete
+		  function call to non-obsolete version.
+
+1997-09-22  Colin Rafferty  <craffert@ml.com>
+
+	* utils/shadow.el (find-emacs-lisp-shadows): Removed extra slash
+		  between directory and filename.
+
+1997-09-23  SL Baur  <steve@altair.xemacs.org>
+
+	* ilisp/Makefile (SHELL): Remove dependency on /bin/csh.
+
+1997-09-23  Hrvoje Niksic  <hniksic@srce.hr>
+
+	* custom/wid-edit.el (widget-move): Use `incf'.
+	(widget-after-change): Ditto.
+	(widget-field-value-get): Ditto.
+	(widget-info-link-help-echo): New function.
+	(info-link): Use it.
+
+	* custom/cus-edit.el (custom-last): Removed.
+	(custom-buffer-create-internal): Use `incf'.
+	(custom-group-value-create): Ditto.
+
+	* packages/auto-save.el: Minor custom fixes.
+
+	* prim/cus-dep.el (Custom-make-dependencies): Generate correct
+	output wrt `custom-put'.
+
+	* custom/wid-edit.el (widget-tabable-at): Use `widget-at'.
+
+	* custom/cus-edit.el (custom-group-value-create): Use
+	`custom-group-visibility' instead of `group-visibility'.
+
+	* prim/help.el (help-map): Bound `C-h C' to `customize'.
+
+	* custom/wid-edit.el (widget-princ-to-string): Don't use `let'.
+	(widget-clear-undo): Removed current-buffer argument.
+	(widget-choose): Use minibuffer when there are more than 10 items.
+
+1997-09-22  Hrvoje Niksic  <hniksic@srce.hr>
+
+	* custom/cus-edit.el (custom-button-face): Made it bold.
+	(custom-group-value-create): Change outlook of buffer.
+	(custom-buffer-create-internal): Ditto.
+	(custom-menu-nesting): Removed -- was unused by XEmacs.
+	(custom-menu-create): Don't use `custom-menu-nesting'.
+	(custom-group-menu-create): Define unconditionally.
+	(customize-menu-create): Ditto.
+	(custom-unlispify-menu-entry): Use `with-current-buffer'.
+
+	* custom/wid-edit.el (widget-checklist-match-inline): Revert to
+ 	`append'.
+	(widget-checklist-value-get): Ditto.
+	(widget-editable-list-match-inline): Ditto.
+	(widget-group-match-inline): Ditto.
+	(widget-glyph-find): Removed compatibility checks; use
+ 	`locate-data-directory'.
+	(widget-glyph-find): Use backquotes.
+	(widget-push-button-value-create): Ditto.
+	(widget-choice-mouse-down-action): Don't use `window-system'.
+	(widget-transpose-chars): New function.
+	(widget-text-keymap): Use it.
+	(widget-princ-to-string): Use `with-current-buffer'.
+	(widget-map-buttons): Ditto.
+	(widget-push-button-gui): Set to value of `widget-glyph-enable' by 
+	default.
+	(widget-push-button-value-create): Call `widget-specify-button'.
+
+	* utils/mail-extr.el: Customized.
+
+1997-09-21  SL Baur  <steve@altair.xemacs.org>
+
+	* packages/man.el: Reverse manual prefix patch.
+
+1997-09-21  Karl M. Hegbloom  <karlheg@inetarena.com>
+
+	* packages/man.el: Got rid of the `stars', and hard coded a prefix
+ 		  of "Man: " for manual-entry buffers.
+
+1997-09-21  Hrvoje Niksic  <hniksic@srce.hr>
+
+	* custom/cus-face.el (frame-background-mode): Renamed from
+	`custom-background-mode'.
+	(frame-background-mode): Rewritten.
+
+	* x11/x-menubar.el: Customized.
+
+	* custom/cus-face.el (face-spec-set-match-display): Use `warn' for 
+	warnings.
+
+	* x11/x-font-menu.el: Customized.
+
+	* modes/reftex.el: Add prefixes to customization groups.
+
+	* custom/cus-edit.el (customize): Accept GROUP.
+	(customize-group): Defalias to `customize'.
+	(customize-other-window): New function.
+	(customize-group-other-window): Alias to `customize-other-window'.
+
+	* custom/wid-edit.el (widget-choose): Now works with
+ 	`widget-menu-minibuffer-flag' set to nil.
+	(widget-menu-minibuffer-flag): Default to nil.
+	(widget-specify-insert): Use new blackquote syntax.
+	(widget-checklist-value-get): Ditto.
+	(widget-map-buttons): Ditto.
+	(widget-checklist-match-inline): Ditto.
+	(widget-editable-list-match-inline): Ditto.
+	(widget-group-match-inline): Ditto.
+	(widget-checklist-match-inline): Use `nconc'.
+	(widget-keymap): Bind `M-tab' to `widget-backward'.
+
+	* prim/help.el (find-function-noselect): `locate-library' is
+ 	compression-aware; don't duplicate the work.
+
+	* prim/packages.el (packages-hardcoded-lisp): Remove "cl-defs".
+
+	* custom/wid-edit.el: Use `remove-if'.
+	(widget-glyph-directory): Use `locate-data-directory'.
+
+	* custom/cus-edit.el (custom-unlispify-remove-prefixes): Default
+	to t.
+
+	* custom/wid-edit.el: Removed *lots* of compatibility stuff.
+
+	* custom/wid-edit.el: (widget-editable-list-value-get): Apply
+ 	`nconc' instead of `append'.
+
+	* custom/wid-edit.el: Ditto.
+
+	* custom/cus-edit.el: Ditto.
+
+	* custom/custom.el: Use `mapc' instead of `mapcar', where
+ 	appropriate.
+
+	* custom/wid-edit.el: Ditto.
+
+	* custom/cus-edit.el: Ditto.
+
+	* custom/custom.el: Ditto.
+
+	* custom/widget.el: Don't define widget keywords.
+
+1997-09-21  Joel Peterson  <tarzan@aosi.com>
+
+	* prim/menubar.el: use normalize-menu-item-name instead of downcase
+	to compare menu item names.
+
 1997-09-20  Hrvoje Niksic  <hniksic@srce.hr>
 
 	* packages/etags.el: Lots of changes.

lisp/calendar/custom-load.el

+;;; custom-load.el --- automatically extracted custom dependencies
+
+;; Created by SL Baur on Sat Sep 27 08:13:36 1997
+
+;;; Code:
+
 (custom-put 'holidays 'custom-loads '("calendar"))
 (custom-put 'calendar 'custom-loads '("calendar"))
 (custom-put 'local 'custom-loads '("calendar"))
 (custom-put 'diary 'custom-loads '("calendar"))
 (custom-put 'appt 'custom-loads '("appt"))
+
+;;; custom-load.el ends here

lisp/cc-mode/custom-load.el

+;;; custom-load.el --- automatically extracted custom dependencies
+
+;; Created by SL Baur on Sat Sep 27 08:13:38 1997
+
+;;; Code:
+
 (custom-put 'c 'custom-loads '("cc-vars"))
+
+;;; custom-load.el ends here

lisp/comint/custom-load.el

+;;; custom-load.el --- automatically extracted custom dependencies
+
+;; Created by SL Baur on Sat Sep 27 08:13:39 1997
+
+;;; Code:
+
 (custom-put 'ssh 'custom-loads '("ssh"))
 (custom-put 'telnet 'custom-loads '("telnet"))
 (custom-put 'shell 'custom-loads '("shell"))
 (custom-put 'processes 'custom-loads '("background" "comint" "rlogin" "shell" "ssh"))
 (custom-put 'background 'custom-loads '("background"))
 (custom-put 'unix 'custom-loads '("rlogin" "shell" "ssh"))
+
+;;; custom-load.el ends here

lisp/comint/telnet.el

 (require 'comint)
 
 (defgroup telnet nil
-  "Telnet/rsh stuff"
+  "Run a telnet session from within an Emacs buffer."
   :group 'comint)
 
 (defvar telnet-new-line "\r")
 
 (defcustom telnet-program "telnet"
   "*Program to run to open a telnet connection."
+  :type 'string
   :group 'telnet)
 
 (defcustom rsh-eat-password-string nil

lisp/custom/ChangeLog

-Fri Sep 19 11:21:15 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9960 released.
-
-Fri Sep 19 11:16:37 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9959 released.
-
-Mon Sep 15 19:40:19 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9958 released.
-
-Mon Sep 15 19:23:36 1997  Hrvoje Niksic  <hniksic@srce.hr>
-
-	* cus-edit.el (custom-menu-create): First load symbol
- 	dependencies, then create menus.  
-	[ Patch modified by Per Abrahamsen ]
-
-Mon Sep 08 19:56:06 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9957 released.
-
-Tue Aug 26 19:43:14 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* custom.el (custom-declare-variable): Changed default initializer
-	to `custom-initialize-reset'.
-
-	* cus-edit.el (custom-variable-save): Fixed doc string.
-
-Fri Aug 15 12:34:58 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (custom-variable-menu): Make it clear that `Lisp
-	mode' edit the initial lisp expression.
-
-Wed Aug 13 13:04:36 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9956 released.
-
-Wed Aug 13 00:28:59 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-face.el (make-empty-face): Make it work on Emacsen compiled
-	without X support.
-
-	* Version 1.9955 released.
-
-Wed Aug 13 00:28:15 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-before-change): Don't complain if
-	`inhibit-read-only' is non-nil.
-
-Mon Aug 11 17:55:02 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-face.el (custom-face-attributes): Don't initialize fg/bg
-	fields. 
-
-Wed Jul 30 14:04:28 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el: Synched with FSF.
-
-Tue Jul 29 07:17:54 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* widget.texi (Programming Example): Also delete overlays.
-
-Mon Jul 28 20:31:22 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9954 released.
-
-Mon Jul 28 19:23:37 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (hook): Support hooks whose value is just a symbol.
-
-	* cus-edit.el (custom-magic-value-create): Support `mismatch'
-	form. 
-	(custom-variable-value-create): Ditto.
-	(custom-variable-set): Ditto.
-	(custom-variable-save): Ditto.
-	(custom-variable-menu): Ditto.
-
-	* Version 1.9953 released.
-
-Mon Jul 28 18:04:46 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-field-add-space): Default to t on all
-	plaforms. 
-
-	* custom.el (defgroup): Doc fix.
-	Patch by karlheg+xemacs@inetarena.com (Karl M. Hegbloom).
-
-	* wid-edit.el (functionp): Use `byte-code-function-p' instead of
-	`compiled-function-p'. 
-	
-	* Version 1.9952 released.
-
-Mon Jul 28 17:52:55 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (functionp): Use `compiled-function-p' instead of
-	`byte-code-function-p'. 
-	(widget-map-buttons): Comment out `parent'.
-	(widget-insert): Don't bind `from'.
-	(widget-move): Dont' bind `new' at start.
-
-	* cus-edit.el (custom-buffer-create-internal): Refer to `mouse-2'
-	instead of `mouse-1'.
-	(customize-browse): Ditto.
-	(custom-mode-map): Don't bind `mouse-1'.
-	(custom-load-symbol): Check that `preloaded-file-list' is bound.
-	(custom-group-value-create): Comment out `indent'.
-
-	* all: Synched with FSF.
-
-Sat Jul 12 01:24:32 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9951 released.
-
-Sat Jul 12 00:29:33 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (customize-save-variable): New command.
-
-	* wid-edit.el (widget-move): Use `previous-overlay-change' and
-	`next-overlay-change'. 
-	(widget-use-overlay-change): New option to control it.
-
-Fri Jul 11 14:25:34 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (custom-save-all): Inhibit read only.
-	Reported by Simon Marshall <Simon.Marshall@esrin.esa.it>.
-
-	* wid-edit.el (regexp): Outcomment :value-face.
-	(file): Ditto.
-
-Thu Jul 10 16:13:36 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9950 released.
-
-Thu Jul 10 16:12:33 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-add-change): Use local hooks.
-	(widget-before-change): Ditto.
-	Suggested by Simon Marshall <Simon.Marshall@esrin.esa.it>.
-
-Wed Jul 09 21:35:05 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9949 released.
-
-Wed Jul  9 20:26:58 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* widget.el (:doc-overlay): New keyword.
-	* wid-edit.el (set-text-properties): Don't define.
-	(widget-specify-none): Delete.
-	(widget-specify-text): Delete.
-	(widget-field-use-before-change): Don't enable for XEmacs.
-	(widget-specify-field): Don't use text properties.
-	(widget-specify-field): Ditto.
-	(widget-specify-doc): Ditto.
-	(widget-specify-insert): Ditto.
-	(widget-insert): Ditto.
-	(widget-convert-text): Ditto.
-	(widget-leave-text): Ditto.
-	(widget-setup): Ditto.
-	(widget-before-change): Ditto.
-	(widget-default-create): Ditto.
-	(widget-default-delete): Ditto.
-	(widget-editable-list-insert-before): Ditto.
-	(widget-editable-list-entry-create): Ditto.
-	(widget-add-change): New function.
-
-	* cus-edit.el (custom-buffer-create-internal): Refer to `mouse-2'
-	instead of `mouse-1'.
-	(custom-mode-map): Don't bind `mouse-1'.
-
-1997-07-09  Steven L Baur  <steve@altair.xemacs.org>
-
-	* custom/cus-edit.el (custom-file): Use same logic as startup.el
-
-Tue Jul 08 13:30:11 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9948 released.
-
-Tue Jul  8 11:34:44 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-field-use-before-change): Doc fix.
-
-1997-07-08  Steven L Baur  <steve@altair.xemacs.org>
-
-	* cus-edit.el (custom-file): Rename .xemacs-custom to something
-	more general.
-
-Mon Jul 07 14:20:33 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9947 released.
-
-Mon Jul  7 14:16:10 1997  Simon Marshall <Simon.Marshall@esrin.esa.it>
-
-	* cus-edit.el (custom-group-members): New function.
-	(custom-group-value-create): Use it rather than get.
-
-Mon Jul  7 11:39:31 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (emacs-library-link): New widget.
-	(widget-emacs-library-link-action): New function.
-	Provided by Stephen Eglen <stephene@cogs.susx.ac.uk>.
-
-1997-07-06  Hrvoje Niksic  <hniksic@srce.hr>
-
-	* wid-edit.el (widget-beginning-of-line): Preserve zmacs region.
-	(widget-end-of-line): Ditto.
-
-Sun Jul  6 21:57:32 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-field-use-before-change): Enable for Emacs
-	20. 
-
-Fri Jul 04 16:24:21 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9946 released.
-
-Fri Jul  4 15:31:45 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-color-sample-face-get): Kludge to make it
-	work before widget is fully created.
-	(widget-color-action): Try to use same relative position of point
-	in minibuffer as it had in the field.
-
-	* cus-edit.el (custom-mode): Document `M-TAB'.
-
-	* custom.texi (Usage for Package Authors): Fixed typo.
-	Patch by Adrian Aichner <aichner@ecf.teradyne.com>.
-
-Fri Jul 04 13:58:14 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* all: Synched with FSF.
-	
-	* Version 1.9945 released.
-
-Fri Jul  4 12:40:13 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* widget.el (:sample-overlay): New keyword.
-	* wid-edit.el (widget-leave-text): Use it.
-	(widget-specify-sample): Use it.
-	(widget-default-delete): Ditto.
-	 (color): Make it an editable field.
-	(widget-color-value-create): Deleted.
-	(widget-color-value-get): Deleted.
-	(widget-color-value-set): Deleted.
-	(color-item): Deleted.
-	(widget-color-item-button-face-get): Renamed to
-	`widget-color-sample-face-get'. 
-	(color-sample): Deleted.
-	(editable-color): Deleted.
-	(widget-editable-color-value-create): Deleted.
-
-Fri Jul 04 11:33:31 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* all: Synched with FSF.
-	
-	* Version 1.9944 released.
-
-Fri Jul  4 11:32:04 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-specify-field): Add newline in overlay for
-	nil-:sized fields.
-	(widget-field-end): Ditto.
-
-Thu Jul  3 19:12:13 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (emacs-library-link): New widget.
-	(widget-emacs-library-link-action): New function.
-	(widgets): Use it.
-	Suggested by Stephen Eglen <stephene@cogs.susx.ac.uk>.
-	(file-link): New widget.
-	(widget-file-link-action): New function.
-
-Wed Jul 02 17:44:40 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9943 released.
-
-Wed Jul  2 17:35:42 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* all: Synched with FSF.
-
-Wed Jul 02 17:19:13 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9942 released.
-
-Wed Jul  2 17:18:08 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (customize-browse): Use glyphs in description, if
-	possible. 
-
-Mon Jun 30 17:07:20 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9941 released.
-
-Mon Jun 30 17:02:21 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-menu-minibuffer-flag): Default to t on
-	XEmacs. 
-
-Thu Jun 26 16:49:32 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9940 released.
-
-Thu Jun 26 15:19:27 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-field-value-create): Add comment explaining
-	why `:field-overlay' contains two markers.
-
-	* cus-edit.el (custom-browse-visibility,
-	custom-browse-visibility-action, custom-browse-group-tag,
-	custom-browse-group-tag-action, custom-browse-variable-tag-action,
-	custom-browse-face-tag, custom-browse-face-tag-action,
-	custom-browse-face-tag-action, custom-browse-alist): Changed
-	prefix from `custom-tree' to `custom-browse'.
-	(custom-variable-value-create, custom-face-value-create,
-	custom-group-value-create): Updated caller.
-
-	* cus-edit.el (custom-browse-only-groups): New option.
-	(custom-group-value-create): Use it.  Omit non-groups if non-nil.
-	Patch by Simon Marshall <Simon.Marshall@esrin.esa.it>.
-
-	* cus-edit.el (custom-help-menu): Renamed "Variable" to "Option".
-	Remove "..." from non-prompting entries.
-	Patch by Simon Marshall <Simon.Marshall@esrin.esa.it>.
-
-	* Version 1.9939 released.
-
-Thu Jun 26 15:16:15 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-single-line-field-face): New face.
-	(widget-single-line-display-table): New variable.
-	(regexp, file): Use `widget-single-line-field-face'.
-	Patch by Hrvoje Niksic <hniksic@srce.hr>.
-	
-Wed Jun 25 20:23:52 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9938 released.
-
-Wed Jun 25 17:46:18 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (custom-unloaded-symbol-p): New function.
-	(custom-unloaded-widget-p): New function.
-	(custom-group-value-create): Use it.
-	(customize-browse): Mention [?].
-
-	* cus-edit.el (custom-toggle-hide): Load dependencies here.
-
-	* wid-edit.el (functionp): New function.
-
-	* Version 1.9937 released.
-
-Wed Jun 25 17:29:08 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* widget.el (:match-alternatives): New keyword.
-
-	* custom.el: Updated autoloads.
-
-	* all: Synched with FSF.
-
-Tue Jun 24 16:27:41 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9936 released.
-
-Tue Jun 24 14:35:17 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (customize-browse): Take a group argument.
-	(custom-help-menu): Browse `emacs' group.
-
-	* Version 1.9935 released.
-
-Tue Jun 24 14:31:53 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9934 released.
-
-Tue Jun 24 14:30:26 MET DST 1997  Simon Marshall <simon@gnu.ai.mit.edu>
-
-	* cus-edit.el (custom-add-parent-links): Simplify mapatoms lambda.
-	(custom-browse): New group.
-	(custom-buffer-groups-last):
-	(custom-menu-groups-first): Options deleted.
-	(custom-browse-sort-alphabetically):
-	(custom-browse-order-groups):
-	(custom-buffer-order-groups):
-	(custom-menu-order-groups): New options.
-	(custom-browse-sort-predicate):
-	(custom-buffer-sort-predicate):
-	(custom-menu-sort-predicate): Functions deleted.
-	(custom-sort-items): New replacement function; simplification and
-	extension of previous predicate functions.
-	(customize-face):
-	(customize-customized):
-	(customize-saved):
-	(customize-apropos):
-	(custom-menu-create):
-	(custom-group-value-create): Use it.
-
-Tue Jun 24 11:46:40 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (custom-tree-alist): Use "-\ " instead of "-+ ".
-	(custom-group-value-create): Ditto.
-
-	* Version 1.9933 released.
-
-Tue Jun 24 11:32:55 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-button-click): Steal up event if key is not
-	bounbd in `widget-global-map'.
-
-Mon Jun 23 17:23:27 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9932 released.
-
-Mon Jun 23 11:56:40 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (custom-tree-insert-prefix): Renamed from
-	`custom-tree-insert'.
-	(custom-group-value-create): Use it.
-
-	* wid-edit.el (widget-field-use-before-change): New option.
-	(widget-setup): Obey it.
-
-	* cus-edit.el (custom-help-menu): Add entry for
-	`customize-browse'. 
-
-	* widget.texi: Change `@br' to `@*'.
-	Patch by Ralph Schleicher <rs@purple.UL.BaWue.DE>.
-
-Sat Jun 21 21:10:57 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9931 released.
-
-Sat Jun 21 14:41:02 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* face.xpm: New file.
-	* option.xpm: New file.
-	* folder.xpm: New file.
-	* Makefile (TEXT): Added.
-	* wid-edit.el (widget-push-button-value-create): Use :tag-glyph.
-	(widget-glyph-insert-glyph): Accept nil widget.
-	* cus-edit.el (custom-tree-group-tag): Specify :tag-glyph.
-	(custom-tree-variable-tag): Ditto.
-	(custom-tree-face-tag): Ditto.
-
-	* Version 1.9930 released.
-
-Sat Jun 21 03:01:17 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* all: Synched with FSF.
-
-	* cus-edit.el (custom-buffer-indent): New option.
-	(custom-magic-value-create): Use it.
-	(custom-group-value-create): Ditto.
-	(custom-buffer-create-internal): Don't create parent groups here.
-	(custom-group-list): New variable.
-	(custom-add-parent-links): New function.
-	(custom-variable-value-create): Use it.
-	(custom-face-value-create): Use it.
-	(custom-group-value-create): Use it.
-	(custom-buffer-groups-last): Changed default.
-
-	* wid-edit.el (group-visibility): Deleted.
-	(widget-group-visibility-create): Ditto.
-	(group-link): Deleted.
-	(widget-group-link-create): Ditto.
-	(widget-group-link-action): Ditto.
-
-	* cus-edit.el (custom-nest-groups): Delete option.
-	(custom-buffer-style): Add `links' style instead.
-	(custom-group-link): New widget.
-	(custom-group-link-action): New function.
-	(custom-group-value-create): Use `custom-group-link'.
-
-	* wid-edit.el (widget-before-change): Fixed comment and debug
-	string. 
-
-	* cus-edit.el (custom-mode-customize-menu): Deleted.
-	(custom-mode-menu): Define here.
-	(custom-mode): Don't add here.
-	(custom-format-handler): Deleted.
-	(custom): Don't add here.
-
-	* all: Synched with FSF.
-	
-	* Version 1.9929 released.
-
-Sat Jun 21 02:05:08 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (custom-browse-sort-predicate): New alias.
-	(custom-group-value-create): Use it.
-	(:custom-last): Replace :custom-extra-prefix.
-	(customize-browse): Use it.
-	(custom-group): Ditto.
-	(custom-group-value-create): Ditto.
-
-	* Version 1.9928 released.
-
-Sat Jun 21 01:35:04 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (face): Fixed format.
-	(custom-face-value-create): Browse face, not option.
-
-	* Version 1.9927 released.
-
-Sat Jun 21 00:03:48 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (custom-group-value-create): Rewrote to replace
-	entire format string. 
-	(custom-variable-value-create): Ditto.
-	(custom-face-value-create): Ditto.
-	(custom-group): Delete :format.
-	(custom-variable): Ditto.
-	(custom-face): Delete :format and :format-handler.
-	(custom): Add :format.
-	(custom-format-handler): Removed unnecessary code.
-	(custom-face-format-handler): Deleted.
-	(custom-add-see-also): New function.
-	(custom-buffer-style): New option.
-	(widget-face-value-create): Use it here instead of :format.
-	(:custom-prefix, :custom-extra-prefix): New keywords.
-	(custom): Initialize them.
-	(custom-redraw-magic): Work with no magic button.
-	(customize-browse): New command.
-	(custom-tree-visibility): New widget.
-	(custom-tree-visibility-action): New function.
-	(custom-tree-group-tag): New widget.
-	(custom-tree-group-tag-action): New function.
-	(custom-tree-group-tag): New widget.
-	(custom-tree-group-tag-action): New function.
-	(custom-tree-variable-tag): New widget.
-	(custom-tree-variable-tag-action): New function.
-	(custom-tree-face-tag): New widget.
-	(custom-tree-face-tag-action): New function.
-
-	* custom.el (customize-browse): Added autoload.
-
-	* cus-edit.el (custom-buffer-sort-alphabetically): New option.
-	(custom-buffer-groups-last): New option.
-	(custom-buffer-sort-predicate): Use them.
-	(customize-apropos): Use it.
-	(custom-group-value-create): Ditto.
-	(custom-menu-sort-alphabetically): New option.
-	(custom-menu-groups-first): New option.
-	(custom-menu-sort-predicate): Use them.
-	(custom-menu-create): Use it.
-	(custom-buffer-sort-predicate, custom-buffer-order-predicate,
-	custom-menu-sort-predicate, custom-menu-order-predicate): Deleted.
-
-Thu Jun 19 17:29:05 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9926 released.
-
-Thu Jun 19 13:31:08 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-leave-text): Don't delete nil overlays.
-
-	* wid-edit.el (widget-get-indirect): New function.
-	(widget-default-create): Use it.
-	(widget-button-insert-indirect): Deleted.
-
-	* wid-edit.el (widget-inactive-face): Use dim gray instead of dark
-	gray.
-
-	* Version 1.9925 released.
-
-Thu Jun 19 12:09:32 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Synched with FSF.
-
-	* Version 1.9924 released.
-
-Thu Jun 19 11:05:38 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (customize-apropos): Always sort apropos.
-	Patch by Simon Marshall <Simon.Marshall@esrin.esa.it>.
-
-	* Version 1.9923 released.
-
-Thu Jun 19 10:59:26 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (custom-reset-saved): Call :custom-reset-saved.
-	(custom-reset-standard): Call :custom-reset-standard.
-
-	* Version 1.9922 released.
-
-1997-06-18  Steven L Baur  <steve@altair.xemacs.org>
-
-	* cus-edit.el (custom-file): Autoload, and use ~/.xemacs-custom
-	for XEmacs.
-
-Wed Jun 18 18:37:00 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (custom-buffer-create-internal): Change parent tag.
-
-	* Version 1.9921 released.
-
-	* cus-edit.el (custom-buffer-create-internal): Add links to parent
-	groups when there is only a single item in the buffer.
-
-Wed Jun 18 13:49:20 1997  Simon Marshall  <simon@gnu.ai.mit.edu>
-
-	* cus-edit.el (customize-apropos): Extend ALL arg to restrict
-	apropos to options, groups and faces.  Doc fix.
-	(customize-apropos-options):
-	(customize-apropos-faces):
-	(customize-apropos-groups): New commands.  Call it.
-	(custom-help-menu): Add commands to menu.
-
-Mon Jun 16 11:57:14 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-documentation-link-add): Only highlight text
-	inside link. 
-	Patch by Simon Marshall <Simon.Marshall@esrin.esa.it>.
-
-1997-06-16  Hrvoje Niksic  <hniksic@srce.hr>
-
-	* wid-edit.el (widget-specify-field): Place unreadable
- 	text-property correctly when `widget-field-add-space' is non-nil.
-
-Sun Jun 15 17:21:34 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* all: Synched with FSF.
-
-	* Version 1.9920 released.
-
-Sun Jun 15 14:06:49 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (custom-variable-menu): Rearranged lisp support.
-	(custom-face-menu): Ditto.
-
-	* wid-edit.el (boolean): Add explicit toggle button.
-	(choice): Add explicit value menu button.
-	* cus-face.el (custom-face-attributes): Use booleans.
-
-	* cus-edit.el (custom-format-handler): Handle %i escape.
-	(custom-face): Use it.
-	(custom-magic-value-create): Add spaces for groups.
-	(custom-format-handler): Add spaces for groups.
-
-	* widget.el (:documentation-indent): New keyword.
-	* wid-edit.el (widget-default-format-handler): Obey it.
-	(widget-documentation-link-add): Add indentation.
-	(widget-documentation-string-value-create): Ditto.
-
-	* Version 1.9919 released.
-
-Sun Jun 15 13:02:02 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (widget-glyph-insert-glyph): Make the invisible
-	extent open ended.
-
-	* cus-edit.el (custom-format-handler): Added :echo-help to
-	visibility widget.
-	(custom-variable-value-create): Ditto, also for tag.
-	* wid-edit.el (widget-documentation-string-value-create): Ditto.
-	(widget-documentation-link-help-echo): New function.
-	(documentation-link): Use it.  Make untabable.
-
-Sat Jun 14 21:57:49 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9918 released.
-
-Sat Jun 14 21:31:09 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-apply-action): Don't bind
-	`after-change-functions' here.
-
-	* cus-edit.el (custom-toggle-hide): Call `widget-setup'.
-
-	* wid-edit.el (widget-setup): Cleanup.
-
-	* Version 1.9916 released.
-
-Sat Jun 14 18:24:36 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-tabable-at): New function.
-	(widget-move): Use it.
-	* wid-edit.el (widget-after-change): Reimplemented :secret.
-
-	* wid-edit.el (widget-field-add-space): New option.
-	(widget-specify-field): Use it.
-	(widget-field-end): Ditto.
-
-	* Version 1.9915 released.
-
-Sat Jun 14 12:12:38 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-leave-text): New function.
-	(widget-convert-text): Use it.
-	(documentation-link): New widget.
-	(widget-documentation-link-action): New function.
-	(widget-documentation-links): New option.
-	(widget-documentation-link-regexp): New option.
-	(widget-documentation-link-p): New option.
-	(widget-documentation-link-type): New option.
-	(widget-documentation-link-add): New function.
-	(widget-documentation-string-value-create): Use it.
-
-	* all: Synched with FSF.
-
-Fri Jun 13 20:25:55 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9914 released.
-
-1997-06-10  MORIOKA Tomohiko  <morioka@jaist.ac.jp>
-
-        * wid-edit.el: Add widget `coding-system' for mule.
-
-Fri Jun 13 14:28:41 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-convert-text): New function.
-	(widget-convert-button): Ditto.
-
-	* custom.texi: Use ../info/custom as file name.
-	(Declaring Variables): Reformulation.
-	Ispelled.
-	* widget.texi: Use ../info/widget as file name.
-	Ispelled.
-	
-Thu Jun 12 19:22:22 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9913 released.
-
-Thu Jun 12 12:15:33 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-field-buffer): Don't assume an overlay
-	exists. 
-	(widget-field-start): Ditto.
-	(widget-field-end): Ditto.
-
-	* cus-face.el (custom-face-attributes-get): Protect against
-	missing w3 font functions.
-
-	* Version 1.9912 released.
-
-Thu Jun 12 12:14:30 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (custom-magic-faces): New group.
-	Added magic faces.
-	
-Wed Jun 11 20:15:33 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9911 released.
-
-Wed Jun 11 14:35:58 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (custom-buffer): New group.
-	(custom-menu): New group
-	Updated options.
-	* wid-edit.el (widget-faces): New group.
-	Updated all faces.
-
-	* wid-edit.el (widget-map-buttons): New function.
-	Written by William M. Perry  <wmperry@aventail.com>.
-
-	* Version 1.9910 released.
-
-Wed Jun 11 13:35:16 1997  Simon Marshall  <simon@gnu.ai.mit.edu>
-
-	* cus-edit.el (custom-buffer-sort-predicate):
-	(custom-menu-sort-predicate): Default to ignore.  Rewrite :type form.
-	(custom-buffer-order-predicate):
-	(custom-menu-order-predicate): New variables.
-	(custom-buffer-sort-alphabetically):
-	(custom-menu-sort-alphabetically): Functions deleted.
-	(custom-sort-items-alphabetically): New function.  Like deleted
-	functions, except that A and B must be the same custom type.
-	(custom-sort-groups-first):
-	(custom-sort-groups-last): New functions.  Like deleted functions,
-	except that only A and B custom types are compared. 
-	(custom-group-value-create):
-	(custom-menu-create): Also sort members using custom-*-order-predicate.
-	But sort the copy of the stored sequence to prevent changing the stored
-	value, and don't store the sorted copy.
-
-Wed Jun 11 11:10:18 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9909 released.
-
-Wed Jun 11 10:13:05 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-specify-inactive): Don't set `mouse-face'.
-	(widget-setup): Don't use markers.
-
-Tue Jun 10 13:55:38 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-default-format-handler): Cleanup.
-	(widget-documentation-string-value-create): Also use documentation
- 	properties on single line documentation strings.
-
-Mon Jun  9 06:21:49 1997  William M. Perry  <wmperry@aventail.com>
-
-	* wid-browse.el (widget-minor-mode): Fixed mistake in
-	  widget-minor-mode - it had semantics of non-interactive calling
-	  reveresed.
-
-Wed Jun  4 13:44:33 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* all: Synched with FSF.
-
-Wed Jun 04 13:24:36 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9908 released.
-
-Tue Jun  3 02:46:21 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-kill-line): Fixed for overlays.
-	Reported by Hrvoje Niksic <hniksic@srce.hr>.
-
-	* cus-edit.el (custom-buffer-create-internal): Show full
-	documentation string in buffers with only a single item.
-	Suggested by Steven L Baur <steve@xemacs.org>.
-
-	* cus-edit.el (custom-mode-map): Suppress keymap.
-
-Tue Jun 03 02:05:13 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9907 released.
-
-Tue Jun  3 00:22:44 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-beginning-of-line): Work with overlays.
-	(widget-end-of-line): Ditto.
-	(widget-specify-inactive): Use inactive for mouse-face as well.
-	(widget-read-event): New alias.
-	(widget-button-click): Use it.
-	Don't execute up events twice.
-	(widget-field-end): Workaround for local-map at
-	end of overlay.
-	(widget-specify-field): Ditto.
-	(widget-move): Fixed but with single button buffers.
-
-Mon Jun  2 23:09:33 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (custom-buffer-create-internal): Improved help
-	strings for reset buttons.
-
-	* wid-edit.el (widget-move): Restored support for
-	`widget-echo-help' and `widget-move-hook'.
-	(widget-documentation-string-value-create): Restore support for
-	`widget-documentation--face'.
-
-1997-06-02  Steven L Baur  <steve@altair.xemacs.org>
-
-	* cus-edit.el (customize-variable-other-window): Added defalias.
-
-Mon Jun  2 21:03:14 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* widget.el (:complete): New keyword.
-	(:complete-function): New keyword.
-	* wid-edit.el (widget-complete): New command.
-	(widget-keymap): Bind it.
-	(widget-complete-field): New option.
-	(widget-default-complete): New function.
-	(default): Bind :complete.
-	(string): Bind :complete-function.
-	(sexp): Ditto.
-
-Mon Jun 02 20:39:28 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9906 released.
-
-Mon Jun  2 23:26:11 1997  Hrvoje Niksic  <hniksic@srce.hr>
-
-	* wid-edit.el (widget-glyph-find): Would infloop when file not found.
-
-Mon Jun  2 17:54:43 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-glyph-find): Try to avoid pure text glyphs.
-	(widget-glyph-insert): Update doc string.
-	Patch by Hrvoje Niksic <hniksic@srce.hr>.
-
-	* wid-edit.el (widget-button-click): Didn't restore `mouse-face'.
-
-Sun Jun  1 20:29:18 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* widget.texi (editable-field): Removed :hide-front-space and
-	:hide-rear-space. 
-	* widget.el: Ditto.
-
-Sun Jun 01 19:55:00 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9905 released.
-
-Sun Jun  1 13:24:07 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el: Changed to overlays.
-	* cus-edit.el (custom-buffer-create-internal): Remove kludge for
-	getting read-only bob and eob in XEmacs.
-	* wid-browse.el (widget-browse-at): Use `get-char-property'
-	instead of `get-text-property'.
-	* widget.el (:value-from :value-to): Deleted.
-	* widget.el (:button-overlay, :field-overlay): New keywords. 
-	* wid-edit.el (widget-default-delete): Delete overlays.
-	(widget-field-value-delete): Delete overlay.
-
-	* wid-edit.el (widget-specify-field-update): Specify both
-	`ballon-help' and `help-echo'. 
-
-Sun Jun 01 13:13:40 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9904 released.
-
-Sun Jun  1 06:34:54 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (visibility): Change "more" to "show".
-
-	* cus-edit.el (:custom-category): New keyword.
-	(custom-variable): Add it.
-	(custom-face): Ditto.
-	(custom-group): Ditto.
-	(custom-magic-value-create): Replace %c with category in state
-	text. 
-	(custom-magic-alist): Use it.
-	(custom-magic-show-hidden): Allow control on each custom
-	category. 
-	(custom-magic-value-create): Ditto.
-	(custom-reset-current): Ignore extra arguments.
-	(custom-reset-saved): Ditto.
-	(custom-reset-standard): Ditto.
-	(custom-reset-button-menu): New option.
-	(custom-buffer-create-internal): Use it.
-
-	* cus-edit.el (customize-variable): Uncomment alias.
-
-	* all: Synched with FSF.
-
-	* cus-edit.el (custom-format-handler): Cleanup.
-
-	* wid-edit.el (widget-kill-line): Use forward-line instead of
-	search-forward.  
-	Suggested by Hrvoje Niksic <hniksic@srce.hr>.
-
-	* cus-edit.el (custom-magic-value-create): Cleanup.
-
-	* wid-edit.el (set-text-properties): Redefine for broken XEmacsen.
-	(widget-field-value-get): Remove workaround.
-	(widget-specify-button): Specify both `ballon-help' and `help-echo'.
-
-Sat May 31 10:41:00 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9903 released.
-
-Sat May 31 08:44:20 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.9902 released.
-
-Sat May 31 08:10:49 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* all: Synched with FSF.
-
-	* Version 1.9901 released.
-
-Sat May 31 03:26:11 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (custom-format-handler): Don't show links for hidden
-	items. 
-
-	* wid-edit.el (widget-button-prefix): Move to `widget-button' group.
-	(widget-button-suffix): Ditto.
-
-	* cus-edit.el (custom-format-handler): New %e and %- escapes.
-	(custom-group): Use them.
-
-	* widget.el (:widget-doc): Removed keyword.
-	* wid-edit.el (widget-help): Removed widget.
-	(widget-help-action): Removed function.
-
-	* widget.el (:documentation-shown): New keyword.
-	* wid-edit.el (documentation-string): New widget.
-	(widget-documentation-string-value-create): New function.
-	(widget-documentation-string-action): New function.
-	(widget-default-format-handler): Use them.
-	* cus-edit.el (custom-toggle-hide): Hide documentation.
-
-	* cus-edit.el (custom-buffer-sort-predicate): Fix :type.
-	(custom-menu-sort-predicate): Ditto.
-
-	* right.xpm: New file.
-	* right-pushed.xpm: New file.
-	* down.xpm: New file.
-	* down-pushed.xpm: New file.
-	* Makefile (TEXT): Add them
-	* wid-edit.el (visibility): New widget.
-	(widget-visibility-value-create): New function.
-	(widget-glyph-find): New function.
-	(widget-glyph-insert): Use it.
-	* cus-edit.el (custom-variable-menu, custom-face-menu,
-	custom-group-menu): Remove `Hide' entry.
-	(custom-magic-show-hidden): New option.
-	(custom-magic-value-create): Use it.
-	(custom-face): Show visibility.
-
-	* custom.texi (The Variable Options): Use dots to show value.
-	(The Face Options): Ditto.
-
-	* cus-edit.el (custom-load-symbol): More code to avoid recursion.
-	Patch by RMS.
-
-Fri May 30 04:44:37 1997  Hrvoje Niksic  <hniksic@srce.hr>
-
-	* wid-edit.el (widget-glyph-insert-glyph): Clean up.
-
-Fri May 30 01:50:05 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* all: Synched with FSF.
-
-	* cus-edit.el (custom-variable-action): Clarified prompt.
-	(custom-face-action): Ditto.
-	(custom-group-action): Ditto.
-
-	* Version 1.9900 released.
-
-Fri May 30 01:02:57 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (custom-face-set): Call `face-spec-set' instead of
-	`custom-face-display-set'. 
-	(custom-face-save): Ditto.
-	(custom-face-reset-saved): Ditto.
-	(custom-face-reset-standard): Ditto.
-
-	* cus-edit.el (custom-buffer-sort-predicate): New option.
-	(custom-buffer-sort-alphabetically): New function.
-	(custom-group-value-create): Use them.
-	(custom-menu-sort-predicate): New option.
-	(custom-menu-sort-alphabetically): New function.
-	(custom-menu-create): Use them.
-
-	* cus-edit.el (custom-magic-alist): Shortened message.
-
-Thu May 29 00:09:41 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el: (custom-help-menu): Updated names.
-
-	* cus-edit.el: Say `invoke' instead of `activate'.
-
-	* wid-edit.el: Ditto.
-	* widget.texi: Ditto.
-	* custom.texi Ditto.
-
-	* wid-edit.el (widget-help): Fix format string.
-
-Wed May 28 17:00:23 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (custom-magic-value-create): Use push button
-	brackets around state button.
-	(custom-magic-value-create): Indent with three spaces.
-
-	* cus-face.el (face-spec-set-match-display): Change error for
-	unknown requirement to warning.
-	Suggested by Hrvoje Niksic  <hniksic@srce.hr>.
-
-Tue May 27 23:37:26 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-link-prefix): Change to "[".
-	(widget-link-suffix): Change to "]".
-
-Tue May 27 20:30:52 1997  Hrvoje Niksic  <hniksic@srce.hr>
-
-	* wid-edit.el (widget-color-item-button-face-get): Don't require
-	facemenu for XEmacs.
-	(widget-glyph-insert): Would bug out.
-
-Tue May 27 16:19:16 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.98 released.
-
-Mon May 26 22:29:22 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-glyph-directory): Fix doc. string.
-	(widget-image-conversion): New option.
-	(widget-glyph-insert): Use it.
-	(widget-glyph-insert-glyph): No tag here.
-	(widget-push-button-value-create): But here.
-	Patch by Hrvoje Niksic <hniksic@srce.hr>.
-
-	* wid-edit.el (widget-field-face): Changed to dim gray.
-	Suggested by Simon Marshall <Simon.Marshall@esrin.esa.it>. 
-
-Sat May 24 00:07:50 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* widget.texi (push-button): Documented new options.
-	(link): Ditto.
-	(Basic Types): Documented new keywords.
-
-	* wid-edit.el (widget-push-button-prefix): New option.
-	(widget-push-button-suffix): New option.
-	(widget-button): New group.
-
-	* widget.el (:text-format): Removed.
-	(:button-suffix): New keyword.
-	(:button-prefix): New keyword.
-
-	* wid-edit.el (widget-button-prefix): New variable.
-	(widget-button-suffix): New variable.
-	(widget-insert-indirect): New function.
-	(widget-default-create): Use it.
-	(default): Bind them.
-	(widget-link-prefix): New option.
-	(widget-link-suffix): New option.
-	(link): Use them.
-	(push-button): Don't use `:text-format'.
-	(widget-push-button-value-create): Ditto.
-	(widget-help): Update format.
-	(checkbox): Ditto.
-	(radio-button): Ditto.
-
-Fri May 23 23:54:11 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (custom-magic-alist): Use `activate' instead of
-	`push'. 
-	* custom.texi (The Face Options): Ditto.
-	* widget.texi (Introduction): Ditto.
-
-Thu May 22 12:49:36 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (custom-magic-alist): Changed rogue state message.
-
-	* custom.el (defface): Doc fix.
-
-Tue May 20 19:17:01 1997  Steven L Baur  <steve@altair.xemacs.org>
-
-	* cus-edit.el (mule): New group for MULE merged emacsen.
-	(auto-save): Spelling fix.
-
-Thu May 15 10:47:20 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* custom.texi (User Commands): Updated documentation.
-
-	* cus-edit.el, custom.el: Renamed `factory' to `standard'
-	everywhere. 
-
-	* cus-edit.el (custom-magic-show-button): Changed default to
-	`nil'. 
-	(custom): Removed `:format'.
-	(custom-variable): Removed level button.
-	(custom-face): Ditto.
-	(custom-level): Deleted.
-	(custom-level-action): Deleted.
-	(custom-format-handler): Update caller.
-	(custom-group-magic-alist): Merged into `custom-magic-alist'.
-	(custom-magic-value-create): Use merged `custom-magic-alist'.
-	(custom-group-state-update): Ditto.
-	
-Wed May 14 19:47:35 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* all: Synched with FSF.
-
-Tue May 13 16:05:34 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (windows): Move to environment.
-
-	* Version 1.97 released.
-
-Fri May  9 12:33:34 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-field-value-get): Add workaround for XEmacs
-	bug with `buffer-substring-no-properties'.
-
-	* widget.texi (atoms): Documented `function', `variable', and
-	`regexp' widgets. 
-
-Thu May  8 14:35:48 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* custom.el (defcustom): Don't wrap in `eval-and-compile'.
-
-	* wid-edit.el (widget-value-convert-widget): Don't convert :value
-	here. 
-
-	* cus-edit.el (custom-buffer-create-internal): New kludge for
-	making bib and eob read-only in XEmacs.
-	Kludge by Hrvoje Niksic <hniksic@srce.hr>.
-
-	* wid-edit.el: Also allow prompt when field value is invalid.
-
-	* cus-edit.el (custom-redraw): Fix repositioning for when column
-	is zero.
-
-Mon May  5 12:55:14 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (x): New group.
-
-Mon Apr 28 13:10:48 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* wid-edit.el (widget-boolean-prompt-value): Always ask.
-
-	* cus-edit.el (custom-variable-value-create): Remove unreferenced
-	variable. 
-	* wid-edit.el (widget-field-action): Ditto.
-	(widget-regexp-match): Ditto.
-
-	* Version 1.96 released.
-
-Mon Apr 28 12:19:24 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (custom-variable-action): Don't update state if it
-	is modified.
-
-	* widget.el (:mouse-down-action): New keyword.
-	* wid-edit.el (button-release-event-p): New function.
-	(widget-keymap): Don't bind mouse up events.
-	(widget-button-pressed-face): New face.
-	(widget-button-click): Wait for up event, give feedback.
-	(default): Use `:mouse-down-action'.
-	(menu-choice): Ditto.
-	(widget-choice-mouse-down-action): New function.
-	(widget-info-link-action): Removed kludge to steal up event. 
-	* cus-edit.el (widget-magic-mouse-down-action): New function.
-	(custom-magic-value-create): Use it.
-	(custom-buffer-create-internal): Removed kludge to steal up event.
-
-Sun Apr 27 12:05:12 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.95 released.
-
-Sun Apr 27 11:10:03 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* widget.el (:glyph-up, :glyph-down, :glyph-inactive): New
-	keywords. 
-	* wid-edit.el (widget-glyph-insert-glyph): Support optional `down'
-	and `inactive' glyphs.
-	(widget-push-button-value-create): Ditto.
-	(widget-glyph-click): New function.
-	(widget-button1-click): Use it.
-	(widget-button-click): Use it.
-
-Sat Apr 26 19:26:45 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* Version 1.94 released.
-
-Sat Apr 26 16:39:58 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* cus-edit.el (custom-buffer-create): Accept optional buffer NAME.
-	(custom-buffer-create-other-window): ditto.
- 	(customize, customize-other-window, customize-variable,
-	customize-variable-other-window, customize-face,
-	customize-face-other-window, customize-customized,
-	customize-saved, customize-apropos, custom-face-menu-create,
-	custom-variable-menu-create, boolean, custom-menu-create): Updated
-	caller. 
-
-	* Version 1.93 released.
-
-	* cus-edit.el (custom-variable-action): Reset magic state.
-	(custom-variable-menu): Allow `Reset to Current' on `changed'
-	items. 
-
-	* wid-edit.el (widget-choice-toggle): New option.
-	(widget-choice-action): Use it.
-
-	* cus-edit.el (custom-group-menu): Only test state to see if the
-	item is enabled. 
-
-	* cus-face.el (custom-background-mode): Use `const', not
-	`choice-item'. 
-	(custom-face-attributes): Use tags for toggling booleans, not the
-	value. 
-
-	* wid-edit.el (character): Use `characterp' when available.
-
-Fri Apr 25 17:05:52 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* widget.el (:prompt-match): New keyword.
-	(:prompt-history): New keyword.
-	(:prompt-internal): New keyword.
-	* wid-edit.el (widget-field-prompt-internal): New function.
-	(widget-field-prompt-value): New function.
-	(editable-field): Use them.
-	(widget-field-action): Ditto.
-	(widget-symbol-prompt-value-history): New variable.
-	(widget-symbol-prompt-internal): New function.
-	(symbol): Use them.
-	(widget-variable-prompt-value-history): New variable.
-	(variable): Use them.
-	(widget-function-prompt-value-history): New variable.
-	(function): Use them.
-
-	* wid-edit.el (boolean): Use tag to toggle.
-	(character, sexp, symbol, file, string): Inactive tag.
-
-	* wid-edit.el (widget-choice-prompt-value): New function.
-	(choice, radio): Use it.
-	(widget-prompt-value): Prepend widget type to prompt.
-
-	* wid-edit.el (widget-parent-action): Renamed from
-	`widget-choice-item-action'. 
-	(choice-item): Updated widget.
-	* cus-edit.el (custom-magic): Ditto.
-	* widget.texi (Defining New Widgets): Documented it.
-
-	* wid-edit.el (widget-children-validate): Renamed from
-	`widget-editable-list-validate'.
-	(editable-list, group): Updated widgets.
-	* cus-edit.el (custom, face): Ditto.
-	* widget.texi (Basic Types): Documented it.
-
-	* wid-edit.el (widget-value-value-get): Renamed from
-	`widget-item-value-get'. 
-	(item): Updated widget.
-	* cus-edit.el (face, custom): Ditto.
-	* widget.texi (Defining New Widgets): Documented it.
-
-	* wid-edit.el (widget-value-convert-widget): Renamed from
-	`widget-item-convert-widget'.
-	(item, editable-field): Updated widgets.
-	* cus-edit.el (face): Ditto.
-	* widget.texi (Defining New Widgets): Documented it.
-
-	* widget.texi (Defining New Widgets): Documented
-	`widget-types-convert-widget' and `widget-children-value-delete'. 
-
-	* custom.texi (User Commands): Documented new commands.
-	
-Thu Apr 24 18:58:54 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* all: Synched with FSF.
-
-Wed Apr 23 20:16:09 1997  Per Abrahamsen  <abraham@dina.kvl.dk>
-
-	* widget.el (define-widget): Return name.